﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using ProtoBuf;

namespace Utility
{
    public class PageRange
    {
        private int start = 0;
        private int end = 0;

        public PageRange(int start, int end)
        {
            this.start = start;
            this.end = end;
        }

        public PageRange()
        {

        }

        public int Start
        {
            get { return start; }
            set { start = value; }
        }

        public int End
        {
            get { return end; }
            set { end = value; }
        }

        public override string ToString()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append(start.ToString());
            builder.Append(",");
            builder.Append(end.ToString());
            return builder.ToString();
        }

        /// <summary>
        /// 范围右移
        /// </summary>
        /// <param name="self"></param>
        /// <param name="interval"></param>
        /// <returns></returns>
        public PageRange Add(int interval)
        {
            return new PageRange(Start + interval, End + interval);
        }

        /// <summary>
        /// 范围左移
        /// </summary>
        /// <param name="self"></param>
        /// <param name="interval"></param>
        /// <returns></returns>
        public PageRange Sub(int interval)
        {
            return Add(-interval);
        }

        /// <summary>
        /// 是否包含
        /// </summary>
        /// <param name="self"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public bool Contains(int value)
        {
            if (value < Start)
            {
                return false;
            }

            if (value > End)
            {
                return false;
            }

            return true;
        }
    }
}
